/Users/bernard/b20/bsoft/include/mg_ctf_fit.h(3)

NAME
/Users/bernard/b20/bsoft/include/mg_ctf_fit.h - Header file for CTF (contrast transfer function) functions.

SYNOPSIS

#include 'rwimg.h'
#include 'ctf.h'

  Functions
Bimage * img_ctf_radial_average (Bimage *p, long n, CTFparam &em_ctf)
Calculates the power spectrum radial average corrected for astigmatism.
double img_ctf_fit (Bimage *p, long n, CTFparam &em_ctf, double lores, double hires, double def_start=1e3, double def_end=2e5, double def_inc=1e3, int flag=0)
Determines the CTF parameters from a power spectrum.
double img_ctf_fit_baseline (Bimage *p, long n, CTFparam &em_ctf, double lores, double hires)
Fits only the baseline for a given CTF.
double img_ctf_fit_envelope (Bimage *p, long n, CTFparam &em_ctf, double lores, double hires)
Fits only the envelope for a given CTF.
double img_ctf_find_defocus (Bimage *p, long n, CTFparam &em_ctf, double lores, double hires, double def_start=1e3, double def_end=2e5, double def_inc=1e3)
Searches for the defocus based on correlation.
double img_ctf_fit_astigmatism (Bimage *p, long n, CTFparam &em_ctf, double lores, double hires)
Fits the astigmatism with a given defocus, baseline and envelope.
double img_water_ring_index (Bimage *p, long img_num, CTFparam &em_ctf)
Calculates the water ring index from a power spectrum.
double img_water_ring_index (Bimage *prad)
Calculates the water ring index from a power spectrum.

Detailed Description

Header file for CTF (contrast transfer function) functions.

Author:
    Bernard Heymann

Date:
    Created: 20000426

    Modified: 20190628

Definition in file mg_ctf_fit.h.

Function Documentation

  double img_ctf_find_defocus (Bimage * p, long n, CTFparam & em_ctf, double lores, double hires, double def_start, double def_end, double def_inc)

Searches for the defocus based on correlation.

Parameters:
    *p image structure.
    n sub-image number.
    &em_ctf CTF parameter structure.
    lores low resolution limit.
    hires high resolution limit.
    def_start defocus search start (default 1e3).
    def_end defocus search end (default 2e5).
    def_inc defocus search increment (default 1e3).

Returns:
    double R factor.

    A radial power spectrum is calculated.
    A range of defocus values is tested (1000-200000 angstrom, 0.1-20 um),
    and the best fitting value accepted.
    The new parameters are written into the CTFparam structure.

Definition at line 391 of file mg_ctf_fit.cpp.

  double img_ctf_fit (Bimage * p, long n, CTFparam & em_ctf, double lores, double hires, double def_start, double def_end, double def_inc, int flag)

Determines the CTF parameters from a power spectrum.

Parameters:
    *p image structure.
    n sub-image number.
    &em_ctf CTF parameter structure.
    lores low resolution limit.
    hires high resolution limit
    def_start defocus search start (default 1e3).
    def_end defocus search end (default 2e5).
    def_inc defocus search increment (default 1e3).
    flag flag to determine astigmatism.

Returns:
    double water ring index.

    Input: Power spectrum or its logarithm.
    A radial power spectrum is calculated.
    A range of defocus values is tested (100-200000 angstrom, 0.01-20 um),
    defining the baseline as passing through the zeroes for each defocus
    and fitting it to a 4th order polynomial.
    The envelope function is a simple gaussian on top of the baseline and
    fitted to minimize the RMSD between the calculated curve and the
    radial power spectrum logarithm.
    The fitting is limited to the spatial frequency range between the
    first and last zeroes.
    Defocus values are positive for underfocus.
    Functions:
        angle = atan(y/x)
        s2 = reciprocal space distance squared
        defocus_average = (defocus_max + defocus_min)/2
        defocus_deviation = (defocus_max - defocus_min)/2
        defocus = defocus_average + defocus_deviation*cos(2*(angle - astigmatism_angle))
        phase = 0.5*PI*lambda*lambda*lambda*Cs*s2*s2 - PI*lambda*defocus*s2 - amp_shift;
        CTF = sin(phase)
    The new parameters are written into the CTPparam structure.

Definition at line 209 of file mg_ctf_fit.cpp.

  double img_ctf_fit_astigmatism (Bimage * p, long n, CTFparam & em_ctf, double lores, double hires)

Fits the astigmatism with a given defocus, baseline and envelope.

Parameters:
    *p image structure.
    n sub-image number.
    &em_ctf CTF parameter structure.
    lores low resolution limit.
    hires high resolution limit

Returns:
    double objective measure (larger is better).

    A radial power spectrum is calculated and the baseline subtracted.
    The defocus deviation starts from a low value to get an estimate of
    the astigmatism angle. The defocus deviation is modified nased on
    the direction of improvements in the fit, at each iteration
    narrowing the angular search for the astigmatism angle.
    The new parameters are written into the CTFparam structure.

Definition at line 557 of file mg_ctf_fit.cpp.

  double img_ctf_fit_baseline (Bimage * p, long n, CTFparam & em_ctf, double lores, double hires)

Fits only the baseline for a given CTF.

Parameters:
    *p image structure.
    n sub-image number.
    &em_ctf CTF parameter structure.
    lores low resolution limit.
    hires high resolution limit

Returns:
    double R factor.

    A radial power spectrum is calculated incorporating astigmatism.
    The baseline of the required type is fit.
    The new parameters are written into the CTFparam structure.

Definition at line 299 of file mg_ctf_fit.cpp.

  double img_ctf_fit_envelope (Bimage * p, long n, CTFparam & em_ctf, double lores, double hires)

Fits only the envelope for a given CTF.

Parameters:
    *p image structure.
    n sub-image number.
    *em_ctf CTF parameter structure.
    lores low resolution limit.
    hires high resolution limit

Returns:
    double R factor.

    A radial power spectrum is calculated incorporating astigmatism.
    The envelope is fit.
    The new parameters are written into the CTFparam structure.

Definition at line 332 of file mg_ctf_fit.cpp.

  Bimage* img_ctf_radial_average (Bimage * p, long n, CTFparam & em_ctf)

Calculates the power spectrum radial average corrected for astigmatism.

Parameters:
    *p image structure.
    n sub-image number.
    &em_ctf CTF parameter structure.

Returns:
    Bimage* radial average, NULL on error.

    A power spectrum with its origin at the center.
    Functions:
        angle = atan(y/x) - astigmatism_angle
        s2 = reciprocal space distance squared
        defocus_min = defocus_avg - defocus_dev
        defocus_max = defocus_avg + defocus_dev
        smin2 = 1 - defocus_dev/defocus_avg
        smax2 = 1 + defocus_dev/defocus_avg
        radius = sqrt(2*s2*(smax2*cos(angle)*cos(angle)+
                    smin2*sin(angle)*sin(angle))/(smax2+smin2))
    The radial average is returned as a new 1D image.

Definition at line 46 of file mg_ctf_fit.cpp.

  double img_water_ring_index (Bimage * p, long img_num, CTFparam & em_ctf)

Calculates the water ring index from a power spectrum.

Parameters:
    *p power spectrum.
    img_num sub-image number.
    &em_ctf CTF parameter structure.

Returns:
    double water ing index.

    A radial power spectrum is calculated.
    The the water ring index is defined as:
        wri = wp/b - 1
    where wp is the intensity at s=0.26 (3.8 Å) and b is the background.
    The background is estimated as the average of sections before and after
    the water peak:
        b1 between s=0.1 and s=0.2
        b2 between s=0.3 and s=0.4

Definition at line 651 of file mg_ctf_fit.cpp.

  double img_water_ring_index (Bimage * prad)

Calculates the water ring index from a power spectrum.

Parameters:
    *prad radial power spectrum.

Returns:
    double water ing index.

    The the water ring index is defined as:
        wri = wp/b - 1
    where wp is the average intensity between 0.2 and 0.3, covering the
    peak at s=0.26 (3.8 Å).
    The background, b, is estimated as the average of sections before and after
    the water peak:
        b1 between s=0.1 and s=0.2
        b2 between s=0.3 and s=0.4

Definition at line 680 of file mg_ctf_fit.cpp.

Author

Generated automatically by Doxygen for Bsoft from the source code.